Subject: Re: [PATCH bpf-next 1/5] selftests/bpf: add remaining ASSERT_xxx() variants

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Mon, 26 Apr 2021 18:44:14 +0200

Andrii Nakryiko <[email-masked]> writes:

> On Mon, Apr 26, 2021 at 8:59 AM Toke Høiland-Jørgensen <[email-masked]> wrote:
>>
>> Andrii Nakryiko <[email-masked]> writes:
>>
>> > On Mon, Apr 26, 2021 at 1:06 AM Lorenz Bauer <[email-masked]> wrote:
>> >>
>> >> On Sat, 24 Apr 2021 at 00:36, Andrii Nakryiko <[email-masked]> wrote:
>> >> >
>> >> > Add ASSERT_TRUE/ASSERT_FALSE for conditions calculated with custom logic to
>> >> > true/false. Also add remaining arithmetical assertions:
>> >> >   - ASSERT_LE -- less than or equal;
>> >> >   - ASSERT_GT -- greater than;
>> >> >   - ASSERT_GE -- greater than or equal.
>> >> > This should cover most scenarios where people fall back to error-prone
>> >> > CHECK()s.
>> >> >
>> >> > Also extend ASSERT_ERR() to print out errno, in addition to direct error.
>> >> >
>> >> > Also convert few CHECK() instances to ensure new ASSERT_xxx() variants work as
>> >> > expected. Subsequent patch will also use ASSERT_TRUE/ASSERT_FALSE more
>> >> > extensively.
>> >> >
>> >> > Signed-off-by: Andrii Nakryiko <[email-masked]>
>> >> > ---
>> >> >  .../selftests/bpf/prog_tests/btf_dump.c       |  2 +-
>> >> >  .../selftests/bpf/prog_tests/btf_endian.c     |  4 +-
>> >> >  .../selftests/bpf/prog_tests/cgroup_link.c    |  2 +-
>> >> >  .../selftests/bpf/prog_tests/kfree_skb.c      |  2 +-
>> >> >  .../selftests/bpf/prog_tests/resolve_btfids.c |  7 +--
>> >> >  .../selftests/bpf/prog_tests/snprintf_btf.c   |  4 +-
>> >> >  tools/testing/selftests/bpf/test_progs.h      | 50 ++++++++++++++++++-
>> >> >  7 files changed, 56 insertions(+), 15 deletions(-)
>> >> >
>> >> > diff --git a/tools/testing/selftests/bpf/prog_tests/btf_dump.c b/tools/testing/selftests/bpf/prog_tests/btf_dump.c
>> >> > index c60091ee8a21..5e129dc2073c 100644
>> >> > --- a/tools/testing/selftests/bpf/prog_tests/btf_dump.c
>> >> > +++ b/tools/testing/selftests/bpf/prog_tests/btf_dump.c
>> >> > @@ -77,7 +77,7 @@ static int test_btf_dump_case(int n, struct btf_dump_test_case *t)
>> >> >
>> >> >         snprintf(out_file, sizeof(out_file), "/tmp/%s.output.XXXXXX", t->file);
>> >> >         fd = mkstemp(out_file);
>> >> > -       if (CHECK(fd < 0, "create_tmp", "failed to create file: %d\n", fd)) {
>> >> > +       if (!ASSERT_GE(fd, 0, "create_tmp")) {
>> >>
>> >> Nit: I would find ASSERT_LE easier to read here. Inverting boolean
>> >> conditions is easy to get wrong.
>> >
>> > You mean if (ASSERT_LE(fd, -1, "create_tmp")) { err = fd; goto done; } ?
>> >
>> > That will mark the test failing if fd >= 0, which is exactly opposite
>> > to what we wan't. It's confusing because CHECK() checks invalid
>> > conditions and returns "true" if it holds. But ASSERT_xxx() checks
>> > *valid* condition and returns whether valid condition holds. So the
>> > pattern is always
>>
>> There's already an ASSERT_OK_PTR(), so maybe a corresponding
>> ASSERT_OK_FD() would be handy?
>
> I honestly don't see the point. OK_PTR is special, it checks NULL and
> the special ERR_PTR() variants, which is a lot of hassle to check
> manually. While for FD doing ASSERT_GE(fd, 0) seems to be fine and
> just mostly natural. Also for some APIs valid FD is > 0 and for other
> cases valid FD is plain >= 0, so that just adds to the confusion.

Alright, fair enough. I just wondered because I had the same feeling of
slight awkwardness when I was writing an fd check the other day, so
thought I'd air the thought; but as you say not *really* a big deal, so
I'm also OK with just using LE or GE for this...

-Toke